/******************************************************************************
 * shaderProgram.h 
 * implements the base class for GLSL shaders
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/

#ifndef SHADER_PROGRAM_H
#define SHADER_PROGRAM_H

#include "globals.h"
#include <map>

// ------------------------------------------------------------
// defines thes shader program class
// 

class CShaderProgram
{
protected:
	virtual bool m_buildShaderProgram();
	
	bool m_checkValidity(GLuint shader);
	
	bool m_compileShader(GLuint &shader, GLenum shadertype, const GLchar *source);
	
public:
		CShaderProgram();
		virtual ~CShaderProgram();

		virtual void use() = 0;

		GLuint getHandle() { return m_shaderProgram; }

		bool isValid();

	protected:

		GLuint m_fragmentShader, m_vertexShader;
		GLuint m_shaderProgram;
};

#endif
